| Qore SalesforceRestDataProvider Module Reference 2.0

Loading...
Searching...
No Matches
Public Member Functions | Public Attributes | Protected Member Functions | Protected Attributes | List of all members
SalesforceRestDataProvider::SalesforceRestObjectDataProvider Class Reference

The SalesforceRestObjectDataProvider data provider class. More...

`#include <SalesforceRestObjectDataProvider.qc.dox.h>`

Inheritance diagram for SalesforceRestDataProvider::SalesforceRestObjectDataProvider:
[legend]

## Public Member Functions
| constructor (SalesforceRestClient rest, string name, hash< auto > sobject)
| Creates the object from the arguments.
*string | getDesc ()
| Returns the data provider description.
string | getName ()
| Returns the data provider name.
Public Member Functions inherited from SalesforceRestDataProvider::SalesforceRestDataProviderBase
| constructor ()
| Creates the object.
| constructor (SalesforceRestClient::SalesforceRestClient rest)
| Creates the object.
| constructor (SalesforceRestClient::SalesforceRestConnection conn)
| Creates the object.
| setLogger (*LoggerInterface logger)
| Accepts a LoggerInterface object for logging (or clears it)

## Public Attributes
string | name
| current object name
const | ProviderInfo = ...
| Static info for the data provider.
hash< auto > | sobject
| sobject description
Public Attributes inherited from SalesforceRestDataProvider::SalesforceRestDataProviderBase
const | ConstructorOptions = ...
| Constructor options.
const | EnvOptions = ...
| Environment options.
const | HttpMethods = ...
| Hash of HTTP Methods.

## Protected Member Functions
*hash< auto > | createRecordImpl (hash< auto > rec, *hash< auto > create_options)
| Creates the given record to the data provider.
int | deleteRecordsImpl (*hash< auto > where_cond, *hash< auto > search_options)
| Deletes zero or more records.
| deleteSingleRecord (string id)
| deletes a single record
*hash< auto > | fixSalesforceRecord (*hash< auto > rec)
| Fix salesforce records for serialization.
| getRecordInfoIntern ()
| Retrieves the record type.
hash< DataProviderInfo > | getStaticInfoImpl ()
| Returns data provider static info.
hash< SalesforceRestRecordInfo > | record_info ()
| Record info for this object.
AbstractDataProviderRecordIterator | searchRecordsImpl (*hash< auto > where_cond, *hash< auto > search_options)
| Returns an iterator for zero or more records matching the search options.
int | updateRecordsImpl (hash< auto > set, hash< auto > where_cond, *hash< auto > search_options)
| Updates zero or more records matching the search options.
| updateSingleRecord (string id, hash< auto > set)
| updates a single record
string | upsertRecordImpl (hash< auto > rec, *hash< auto > upsert_options)
| Upserts the given record to the data provider.

## Protected Attributes
hash< auto > | desc
| The description of this object type.
Protected Attributes inherited from SalesforceRestDataProvider::SalesforceRestDataProviderBase
*SalesforceRestClient::SalesforceRestConnection | conn
| The connection object used to create the REST client.
SalesforceRestClient::SalesforceRestClient | rest
| The REST client object for API calls.

## Additional Inherited Members
Static Protected Member Functions inherited from SalesforceRestDataProvider::SalesforceRestDataProviderBase
static *hash< auto > | getClientOptions (*hash< auto > copts)
| Returns options for the SalesforceRestClient.

## Detailed Description

The SalesforceRestObjectDataProvider data provider class.

## Member Function Documentation

## ◆ createRecordImpl()

*hash< auto > SalesforceRestDataProvider::SalesforceRestObjectDataProvider::createRecordImpl | ( | hash< auto > | rec,
|  | *hash< auto > | create_options )
| protected

Creates the given record to the data provider.

Parameters

  rec | a hash representing a single input record
  create_options | the create options after processing by validateCreateOptions()

Returns
  the data written to the data provider with the `"id"` field of the new record

Exceptions

  DUPLICATE-RECORD | this exception should be thrown if the provider fails due to an attempt to create a duplicate record

## ◆ deleteRecordsImpl()

int SalesforceRestDataProvider::SalesforceRestObjectDataProvider::deleteRecordsImpl | ( | *hash< auto > | where_cond,
|  | *hash< auto > | search_options )
| protected

Deletes zero or more records.

Parameters

  where_cond | a hash for identifying the record(s) to be deleted
  search_options | the delete options after processing by validateSearchOptions()

Returns
  the number of records deleted

## ◆ fixSalesforceRecord()

*hash< auto > SalesforceRestDataProvider::SalesforceRestObjectDataProvider::fixSalesforceRecord | ( | *hash< auto > | rec | ) |
| protected

Fix salesforce records for serialization.

Ensure that:

- `DATE` fields are serialized as YYYY-MM-DD strings
- `TIME` fields are serialized as HH:mm:SS.xx strings

## ◆ searchRecordsImpl()

AbstractDataProviderRecordIterator SalesforceRestDataProvider::SalesforceRestObjectDataProvider::searchRecordsImpl | ( | *hash< auto > | where_cond,
|  | *hash< auto > | search_options )
| protected

Returns an iterator for zero or more records matching the search options.

Parameters

  where_cond | the search criteria
  search_options | the search options after processing by validateSearchOptions()

See also
  requestSearchRecordsImpl()

## ◆ updateRecordsImpl()

int SalesforceRestDataProvider::SalesforceRestObjectDataProvider::updateRecordsImpl | ( | hash< auto > | set,
|  | hash< auto > | where_cond,
|  | *hash< auto > | search_options )
| protected

Updates zero or more records matching the search options.

Parameters

  set | the hash of field data to set
  where_cond | a hash for identifying the record(s) to be updated
  search_options | the update options after processing by validateSearchOptions()

Returns
  the number of records updated

## ◆ upsertRecordImpl()

string SalesforceRestDataProvider::SalesforceRestObjectDataProvider::upsertRecordImpl | ( | hash< auto > | rec,
|  | *hash< auto > | upsert_options )
| protected

Upserts the given record to the data provider.

Parameters

  rec | a hash representing a single input record
  upsert_options | the create options after processing by validateUpsertOptions()

Returns
  see db_provider_upsert_results for possible values